<?php


include("common.php");
include("JSON.php");


/* Set the no-cache header. */
header("Cache-Control: no-cache");


function emit_status($istat, $sstr)
{
  $sjson = new Services_JSON();
  $status_return = array("status" => $istat, "error" => $sstr);
  header("X-JSON: " . $sjson->encode($status_return));
  echo $sjson->encode($status_return);
}



if (!isset($_GET["filename"]))
{
  /* Error: No filename specified. */
  emit_status(0, "No filename specified");
  exit;
}


$file_name = $_GET["filename"];


$files = all_files_in_dir($download_dir);

/* Check if the file whose download needs to be cancelled is in the
 * list of files that the user owns.
 *
 */

$file_list = get_file_list_from_cookie($cookie_name);

// echo $file_name . "<br>\n";

// print_r($file_list);


if (!in_array($file_name, $file_list))
{
  /* Error: You do NOT own this file. */
  emit_status(0, "You do NOT own this file");
  exit;
}

/* The file exists in the user's own file list. */

if (!in_array($file_name, $files))
{
  /* Error: File does NOT exist. */
  emit_status(0, "File does NOT exist");
  exit;
}

/* The file exists on disk. */

/* Get the PID of the downloading process. */

$fmd_path = $metadata_dir . $file_name;
$file_metadata = file($fmd_path);

if ($file_metadata === FALSE)
{
  /* Error: Can NOT cancel this download. Metadata missing. */
  emit_status(0, "Can NOT cancel this download. Metadata missing");
  exit;
}

$dpid = intval($file_metadata[4]);

// echo $dpid . "<br>\n";

/* Send a SIGTERM signal to the downloading process. */
$kret = posix_kill($dpid, 15);

if ($kret === FALSE)
{
  /* Error killing the downloading process. */
  emit_status(0, posix_strerror(posix_get_last_error()));
  exit;
}

/* Update the status of the download to "cancelled". */

/* $file_metadata is valid here. */

/* Write out a '2' to the 'status' flag in the metadata information
 * file.
 */
$file_metadata[3] = "2\n";

/* Write out the metadata file's contents to disk. */

write_string_to_file($fmd_path, implode("", $file_metadata));

/* Send a successful completion status to the user. */
emit_status(1, "The download was cancelled successfully!!!!");



?>
