<?php

$download_dir = "/download/data/";
$metadata_dir = "/download/metadata/";
$cookie_name = "file_list";
// $php_exec_path = "/opt/lampp/bin/php";
$php_exec_path = "php";
$proxy_host = "172.16.1.33:8080";


/* Values for the field "status" in the metadata file for a download.
 *
 * 0 => Download is currently not running. i.e. Has run to completion.
 * 1 => Download _might_ be currently running.
 * 2 => Download has been "cancelled" by the user.
 * 3 => Status of this download is _unknown_ because of a missing
 *      metadata file for this download.
 *
 */


function file_name_from_URL($url)
{
  $fname = "";

  while (strlen($url) > 0 && $url[strlen($url) - 1] == "/")
  {
    $url = substr($url, 0, strlen($url) - 1);
  }


  if (strlen($url) == 0)
  {
    return "unknown";
  }

  /* Get the last component of the URI, and store that as the file name. */

  $fname = strrchr($url, "/");
  if (strlen($fname) == 0)
  {
    $fname = "index.html";
  }
  else
  {
    $fname = substr($fname, 1);
  }

  /* Strip any GET request query terms from the file name. */

  $question_pos = strpos($fname, "?");

  if ($question_pos !== FALSE)
  {
    $fname = substr($fname, 0, $question_pos);
  }

  return $fname;

}



function get_file_list_from_cookie($cookie_name)
{
  $files_array = array();

  if (isset($_COOKIE[$cookie_name]))
  {
    $users_files = $_COOKIE[$cookie_name];
    $files_array = explode("/", $users_files);
  }

  return $files_array;
}


/* This function is here because PHP4 lacks a file_put_contents() 
 * function.
 *
 */
function write_string_to_file($file_name, $str)
{
  $fh = fopen($file_name, "w");
  if ($fh === FALSE)
    return FALSE;

  $bwritten = fwrite($fh, $str);

  fclose($fh);
  return $bwritten;
}


/* Format of the metadata file. Each line contains some information.
 *
 * [1] URL.
 * [2] File Size if deteriminable or -1.
 * [3] Download Start Time.
 * [4] Is download currently running? [0/1].
 * [5] The PID of the download process.
 *
 */
function write_metadata($url, $fname, $file_size, $start_time, $dpid)
{
  global $metadata_dir;
  $file_to_write_to = $metadata_dir . $fname;
  $data_to_write = $url . "\n" . $file_size . "\n" . $start_time . "\n" . "1" . "\n" . $dpid . "\n";
  return write_string_to_file($file_to_write_to, $data_to_write);
}


function all_files_in_dir($dir_path)
{
  $dh = opendir($dir_path);

  if (!$dh)
    die("Error opening directory: ". $dir_path . "\n");

  $files = array();


  while (($file = readdir($dh)) != FALSE)
  {
    if ($file != "." && $file != "..")
    {
      $files[ ] = $file;
    }
  }

  closedir($dh);
  return $files;
}




?>
