/* The code for our downloader. 
 *
 * Requires prototype.js and tabber.js
 *
 */

/* currentIndex holds the index number of the current tab. 
 * 0 means the 'My downloads' tab is active.
 * 1 means that the 'All downloads' tab is active. 
 */

var currentIndex = 0;

/* currentTab refers to the <div> element of the current tab */

var currentTab;

/* The timer that refreshes the content */

var dlTimer;


/* The path prefix of the php files */

var pathPrefix;

/* THe default text of the filter text field */

var filterTextDefStr="Filter Results";

/* The default value for the download url text field */

var urlTextDefStr = "Enter the URL of the file to download";


/* The variable which holds the text based on which the file listing
is filtered */

var currFilterText = filterTextDefStr;



function downloadFile()
{
    var url = pathPrefix + '/download.php'; 
    var parameters =  $('fileURL').value;

    new Ajax.Request(url, {
		     method: 'get',
		     parameters: {url : parameters},
		     onSuccess: function(transport, json){
			 if (json.status == 0) {
			     alert ('An error occured while trying to download from URL:\n\n\t\"'+ json.filename + '\"\n\nPlease make sure that the URL is valid.');
			 }
		     },
		     onFailure: function(){
			 alert ('An error occured while trying to download the file. \nThe server may be malfunctioning. \nPlease contact the system administrator.');
		     },
		     onException: function(object, exception){
			 alert ('Sorry but the following exception occurred while processing your request: \n\n\t' + exception);
		     }
    });

    // Reset the contents of the text box
    urlText = 0;
    $('fileURL').style.color = "gray";
    $('fileURL').value = urlTextDefStr;
}

function cancelDownload(fileName)
{
    var url = pathPrefix + '/cancel.php';

    if (confirm ('Are you sure you want to stop downloading the file \n\n\t* ' + fileName + ' ?')){
	new Ajax.Request(url, {
	    method : 'get',
	    parameters : {filename : fileName},
	    onSuccess: function(transport, json){
		if (json.status == 0){
		    // There was an error with cancelling the
		    // download. Alert the user by printing the error
		    // string
		    
		alert ('Sorry, but the following error occurred while trying to cancel your download : \n\n\t' + json.error);
		}  
	    },
	    onFailure : function(){	    
		alert ('An error occurred while contacting the server. Please report this to the system administrator or try again later.');
	    },
	    onException : function(object, exception){
	    alert ('Sorry, but the following exception occurred while trying to cancel your download \n\n\t' + exception);
	    }
	});
    }
    
}

 
function drawPage(){
    if (currentIndex == 0)getFileListing('my');
    else if (currentIndex == 1) getFileListing('all');
}


function getFileListing(dlType){
    /* Use AJAX to fetch the appropriate file listing. */
    var url = pathPrefix + '/file_list.php';


    new Ajax.Request(url,
		     {
			 method:'get',
			 parameters: {showtype: dlType},
			 onSuccess: function (transport){
			     var response = transport.responseText || -1;
			     drawTable(response);
			 },
			 onFailure: function(){ 
			     dlTimer.stop();
			     alert('The download server is malfunctioning and cannot be used at the moment.\nPlease report this incident to the System Administrator and try again later.\nWe are sorry for the inconvenience caused.');
			     $(currentTab).update("<p>Failure..</p><p>If you are feeling optimistic, you may try your luck reloading this page in your browser window.\n<img src=\"images/smile.png\"></p>");

			 },
			 onException: function(object, exception) {
			     $(currentTab).update(errorMessage('getFileListing', exception));
			 }
		     }
		    );
}   


function drawTable(rawText){
    /* rawText will be JSON objects separated by  ;  . The JSON object will be of the form
     *
     *    { "url" : "urlString",
     *      "fname" : "fileName",
     *      "bdone" : BytesDone,
     *      "btot" : BytesTotal,
     *      "tstart" : startTime,
     *      "tcurr" : currentTime,
     *      "status" : 0 == download complete / 
     *                 1 == download running /
     *                 2 == download cancelled /
     *                 3 == status unknown
     *    }
     *
     * Generate the table code for this, and update currentTab to show
     * this new table 
     */
    if (rawText == -1){
	    $(currentTab).update("<p>There are no files to show in this view. </p>");
	return false;
    }

    // Get the rawText into the appropriate format, ie. as JSON
    // objects reverse sorted on the start time
    
    var fileListing = new Array();
    fileListing = rawText.split(';');    

    var jsonListing = new Array();
    $(fileListing).each( function(entry){
	if (entry != '' && entry != '\n'){
	    jsonListing.push(entry.evalJSON());
	}
    })
    
    jsonListing = jsonListing.sortBy( function(s) {
	return s.tstart;
    });

    jsonListing = jsonListing.reverse();
    
    // We now have the file listing as JSON objects and reverse
    // sorted on the start time. We can now iterate
    // straightforwardly through the array to display the
    // files. 


 
    var content = "<div class=\"canvas\" id=\"MyDivFoo\">";    
    
    var count = 0;

    // Get the current value of the filter text.

    try {
	currFilterText=$('filterText').value;
    }
    catch (e){
	// The filter text link has not yet been clicked. Set
	// currFilterText to the default value
	currFilterText = filterTextDefStr;
    }


    jsonListing.each( function(entry){

	if (currFilterText != filterTextDefStr){
	    // We need to do some filtering. 
	    var tmp = entry.fname;	    
	    if ( tmp.search(currFilterText) == -1) {
		//The present file name does not satisfy the filter. Skip it.
		return;
	    }
	}

	var eo;
	
	if (isEven(count)) eo = "even";
	else eo = "odd";
	
	content += "<div class=\"" + eo + "\">"
	content += "<a href=\"" + pathPrefix + "/files/" + entry.fname + "\">" + unescape(entry.fname.truncate(40)) + "</a>";
	content += " from " + unescape((entry.fname.length >= 40)  ? entry.url.truncate(15) : entry.url.truncate(55 - entry.fname.length));

	if (entry.status != 3){
	    // Display a link only if we have one 
	    content += " (<a href=\"" + (entry.url.startsWith('http://') ? '' : 'http://') + entry.url + "\">link</a>)";
	}
 
	if (currentIndex == 0 && entry.status == 1) {

	    // We are currently viewing the My Downloads section and
	    // the download is active. Show the cancel button.

	    content += " (<span class=\"cancel\" onClick=\"cancelDownload('" + entry.fname + "')\">cancel</span>)";
   
	}
 	content += "<br />";
	
	content += "<span class=\"speed\">"; 
	
	var size = new Sizing(entry.bdone);
	content += size.scaledValue().toFixed(2).toString();
	content += ' ' + size.scaledUnit() + ' ';
	
	if (entry.btot != -1){
	        
	    var totsize = new Sizing (entry.btot);
	    content += 'of ' + totsize.scaledValue().toFixed(2).toString();
	    content += ' ' + totsize.scaledUnit();

 	} else content += 'of ???';

	content += ' at ';
 
	if (entry.tcurr - entry.tstart != 0){
	    var dlSpeed = entry.bdone / (entry.tcurr - entry.tstart);
	    dlSpeed /= 1024;
	    dlSpeed = Math.round(dlSpeed);

	    content += dlSpeed + 'KB/s';
	}
	else content += '??? KB/s';

	content += "</span>"; // class="speed"

	
	if (entry.status == 0){
	    // The download is complete.
	    content += "<i>Download Complete!</i>";
	} 
	else if (entry.status == 1){
	    // The download is still on
	    
	    if (entry.btot == -1){
		//We don't know the total size of the file. So we cant show a progress bar
		content += 'Downloading...';
	    }
	    else {
		// Calculate the percentage done and display a progress bar
		var p = (entry.bdone / entry.btot) * 100; 
		
		content += "<span style=\"width:180px;\"><img src=\"images/percentImage.png\" style=\"width:120px; height:12px; background-position: " + Math.round(100 - p) +  "% 50%; background-image:url('images/percentImage_back1.png'); padding:0; margin:0\"/></span>";
		content += " " + Math.round(p) + "%";
		
	    } 
	}
	else if (entry.status == 2){
	    // The download has been cancelled
	    content += "<i>Download Cancelled.</i>";
	} 
	else if (entry.status == 3){
	    // The status of the file is unknown
	    content += "<i> Status of file unknown.</i>";
	}
	
	
	content += "</div>";
	++count;

    });
    
    if (count == 0) content += "<div class=\"even\"> No files match the search criteria </div>";
    
    content += "</div>";

    $(currentTab).update(content); 
    $(currentTab).style.height = "400px";
    $(currentTab).style.overflow = "auto";


    return true;
    
}



function isEven(num) { return ( (num%2 == 0) ? true:false) ; }



// Class : Sizing 

// This class scales a given number to an appropriate
// size range (ie bytes, KB, or MB)

var Sizing = Class.create({
    initialize: function(value){
	this.value = value;
    },
    _compute : function () {
	if (this.value >= 1024 * 1024){
	    this.scaled = this.value / (1024*1024);
	    this.unit = 'MB';
	} 
	else if ( this.value >= 1024){
	    this.scaled = this.value / 1024;
	    this.unit = 'KB';
	}
	else {
	    this.unit = 'bytes';
	    this.scaled = this.value / 1;
	}
    },
    scaledValue: function(){
	this._compute();
	return this.scaled;
    },
    scaledUnit: function(){
	this._compute();
	return this.unit;
    }
});



// Submit the download form if the enter key is pressed.

function checkEnter(e){ //e is event object passed from function invocation
    var characterCode; // literal character code will be stored in this variable
    
    if(e && e.which){ //if which property of event object is supported (NN4)
	characterCode = e.which; //character code is contained in NN4's which property
    }
    else characterCode = e.keyCode; //character code is contained in IE's keyCode property
   
    if(characterCode == 13){ //if generated character code is equal to ascii 13 (if enter key)
	//submit the form
	$('fileURL').blur();
	downloadFile();
    }
}



//Reset the contents of the text box

function fillText(fieldName, fillString, fillColor)
{
    if ($(fieldName).value.blank()){
	$(fieldName).style.color = fillColor;
	$(fieldName).value = fillString;
    }
}


//Erase the contents of the text box

function eraseText(fieldName, fillString, fillColor)
{
    if ($(fieldName).value == fillString ){
	$(fieldName).style.color = fillColor;
	$(fieldName).value='';
    }
}


// Create good error messages

function errorMessage(location, exception)
{
    var message = "<div class=\"error\">";
    message += "<p>Sorry, we encountered an exception. Here are the details : </p>";

    message += "<p>Exception occured in : " + location + "</p>";
    if (exception){
	message += "<p>Exception Name : " + exception.name + "</p>";
	message += "<p>Exception Message : " + exception.message + "</p>";
    }

    message += "<p>Please notify the system administrator about this.</p>";

    message += "</div>";
    
    return message;
}

function filterClicked()
{

    var content = "<input type=\"text\" id=\"filterText\" onBlur=\"fillText(\'filterText\', filterTextDefStr)\" onClick=\"eraseText(\'filterText\', filterTextDefStr)\" size=\"20\" style=\"color:gray; border:1px dotted #999999; background-color:#EEEEEE; color:#666666\">";

    content += "<br> <span style=\";font-size:60%; text-decoration:underline; color:#999999;cursor:pointer\" onClick=\"closeClicked()\">close</span>";


    $('filter').update(content);

    $('filterText').focus();

}


function closeClicked()
{
    
    var content = " <span style=\"font-size:80%; color:#666666; text-decoration:underline;cursor:pointer;\" onClick=\"filterClicked()\"> Filter Results </span>"

    $('filter').update(content);
}

  
