<?php


$file_name_suffix = 0;


include("common.php");
include("curl_helper.php");
include("JSON.php");

$sjson = new Services_JSON();



function check_file_exists($file_name)
{
  global $download_dir;
  return file_exists($download_dir . $file_name);
}


function get_next_name($file_name)
{
  global $file_name_suffix;

  ++$file_name_suffix;
  return $file_name . "." . $file_name_suffix;
}



$url = urldecode($_GET["url"]);

// $url = "www.google.com";

/* Check if the URL is valid. */

/* Set the no-cache header. */
header("Cache-Control: no-cache");


$hresp = new HEAD_response($url);

// echo "HTTP Response Code: " . $hresp->code . "\n";

if (!($hresp->code == 200 || $hresp->code == 405))
{
  /* There was an error. */
  $error_return = array("status" => 0, "filename" => $url);

  header("X-JSON: " . $sjson->encode($error_return));
  echo $sjson->encode($error_return);

  exit;
}


/* The URL is valid and exists. */

/* Determine the file name for the current download. */

$fname = file_name_from_URL($url);
$fname_orig = $fname;


while (check_file_exists($fname) != FALSE)
{
  $fname = get_next_name($fname_orig);
}


// echo "File Name: " . $fname . "\n";


/* The file with name '$fname' does NOT exist. */


/* Write out the meta-data information to the metadata file for this download. */


$file_size = -1;
if (isset($hresp->headers["Content-Length"]))
{
  $file_size = $hresp->headers["Content-Length"];
  if ($file_size == 0)
  {
    $file_size = -1;
  }

}

/* Send a cookie to the client indicating the file name of the saved file. */

/* First, get the existsing cookie value(if any). */
$files_array = get_file_list_from_cookie($cookie_name);


/* Add the new file to the files array. */
$files_array[ ] = $fname;

// print_r($files_array);



/* Cookie expires in 400 days time. */

setcookie($cookie_name, implode("/", $files_array), time() + 34560000);


/* BUG-FIX: The file_list.php script used to reset the cookies, if the
 * following usage pattern occurred.
 *
 * T0  T1  T2  T3                                                TN
 * ----------------------------------------------------------------
 * ^   ^   ^   ^
 * |   |   |   |
 * |   |   |   --- The download is started, but does not show up in
 * |   |   |       the user's "My Downloads" tab!!!!
 * |   |   |
 * |   |   ------- file_list.php is called which sees that the cookie
 * |   |           has a file name set, but that file does not
 * |   |           exist. file_list.php sends back a cookie clearing
 * |   |           that file.
 * |   |
 * |   ----------- A cookie saying that the file belongs to the user
 * |               is sent back to him/her. However, the file is NOT
 * |               yet created on the server.
 * |
 * --------------- User enters a URL to download.
 *
 * To fix this BUG, we 'touch' the file that is going to be created by
 * the do_download.php script before wqe send the cookie to the
 * client.
 *
 */

/* Assume that the function below always suceedes. */

touch($download_dir . $fname);


/* Now, start the download. */

$command_str = "$php_exec_path do_download.php \"$url\" \"$fname\" \"$file_size\" > /dev/null 2>&1 &";

// echo $command_str . "\n";


exec($command_str);

$success_return = array("status" => 1, "filename" => $fname);

header("X-JSON: " . $sjson->encode($success_return));

echo $sjson->encode($success_return);

?>
