<?php


/* File Descriptor for the output file. */
$fd = -1;

/* Number of bytes of the file downloaded. */
$done = 0;

/* Number of bytes downloaded in this session. */
$sbytes = 0;

/* The URL we are downloading from. */
$url = "";

$fname = "";
$start_time;


$chunk_size = 4194304; // 4MB
// $chunk_size = 262144; // 256kB


include("curl_helper.php");


function pretty_bytes($bytes)
{
  $ret = $bytes . "b";

  if ($bytes > 1073741824) // 1GB
  {
    $ret = round($bytes / 1073741824, 2) . "GB";
  }
  else if ($bytes > 1048576) // 1MB
  {
    $ret = round($bytes / 1048576, 2) . "MB";
  }
  else if ($bytes > 1024) // 1kB
  {
    $ret = round($bytes / 1024, 2) . "kB";
  }

  return $ret;

}


function show_progress()
{
  global $done;
  global $start_time;
  global $fsize;
  global $sbytes;

  $pstr = pretty_bytes($done) . " / " . pretty_bytes($fsize) . " done. " . 
	  intval($done / $fsize * 100.0) . "% Complete at " . 
	  round($sbytes / (time() - $start_time) / 1024.0, 1) . "kbps.";

  $blanker = str_repeat(" ", strlen($pstr));
  $backer = str_repeat(chr(8), strlen($pstr));

  echo $pstr . $backer;
}


function http_body_reader($ch, $str)
{
  /* This is the GET response. */
  global $fd;
  global $done;
  global $sbytes;

  /* Write the string to the file. */
  $written = fwrite($fd, $str);

  if ($written != strlen($str))
    die("Error writing " . strlen($str) . " bytes to the file.\n");

  $done += $written;
  $sbytes += $written;

  show_progress();

  return $written;

}


function download_chunk($url, $writer_proc, $headers)
{
  $conn = new CCurl();

  $conn->set_url($url);
  $conn->include_header(0);
  $conn->set_http_request_method("GET");
  $conn->set_writer_function($writer_proc);
  $conn->set_headers($headers);

  $conn->execute();
  $conn->close();
}


if ($_SERVER["argc"] < 3)
{
  die("Usage: " . $_SERVER["argv"][0] . " <\"FILE NAME\"> <\"URL\">\n");
}


$fname = $_SERVER["argv"][1];
$url   = $_SERVER["argv"][2];

// $fsize = $_SERVER["argv"][3];



$hresp = new HEAD_response($url);

if (!($hresp->code == 200 || $hresp->code == 405))
{
  /* There was an error. */
  die("Error getting the HEAD information.\n");
}

if (!isset($hresp->headers["Content-Length"]) || $hresp->headers["Content-Length"] == 0)
{
  die("Error getting the Content-Length Header.\n");
}

echo "Saving: " . $fname . "\n";
echo "From: " . $url . "\n";

$fsize = $hresp->headers["Content-Length"];

echo "The file size is: " . $fsize . "\n";

if (file_exists($fname) !== FALSE)
{
  $done = filesize($fname);
  echo "Continuing download....\n";
}


$fd = fopen($fname, "a");

if (!$fd)
  die("Error opening file: " . $fname . " for APPENDING.\n");

$start_time = time();


while ($done < $fsize)
{
  $headers = array();
  $start = $done;
  $end = $done + $chunk_size;
  $end = ($end > $fsize ? $fsize : $end);

  $headers[ ] = "Range: bytes=" . ($start) . "-" . ($end);

  // print_r($headers);

  download_chunk($url, "http_body_reader", $headers);
}

echo "\nDownload Complete.\n";


?>
