<?php


class CCurl
{
  public $m_handle;
  public $m_header;
  public $m_body;
  public $m_url;
  public $has_body;
  public $has_header;


  public function CCurl()
  {
    $this->m_handle = curl_init();

    $this->has_body = 1;
    $this->has_header = 0;

    curl_setopt($this->m_handle, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_0);
    curl_setopt($this->m_handle, CURLOPT_FORBID_REUSE, 1);
    curl_setopt($this->m_handle, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($this->m_handle, CURLOPT_FOLLOWLOCATION, 1);
    // curl_setopt($this->m_handle, CURLOPT_NOPROGRESS, 0);
    // curl_setopt($this->m_handle, CURLOPT_VERBOSE, 1);

    return;
  }


  public function set_writer_function($proc_name)
  {
    $this->has_body = 0;
    curl_setopt($this->m_handle, CURLOPT_WRITEFUNCTION, $proc_name);
  }

  public function set_http_request_method($method_name)
  {
    curl_setopt($this->m_handle, CURLOPT_CUSTOMREQUEST, $method_name);
  }

  public function set_headers($harray)
  {
    curl_setopt($this->m_handle, CURLOPT_HTTPHEADER, $harray);
  }


  public function include_header($ih)
  {
    $this->has_header = $ih;
    curl_setopt($this->m_handle, CURLOPT_HEADER, $ih);
  }

  public function set_url($url)
  {
    $this->m_url = $url;
    curl_setopt($this->m_handle, CURLOPT_URL, $this->m_url);
  }

  public function execute()
  {
    $sResponse = curl_exec($this->m_handle);

    // echo strpos($sResponse, "\r\n\r\n") + 4 . "\n";

    if ($sResponse != FALSE)
    {
      if ($this->has_header != 0)
        $this->m_body = substr($sResponse, strpos($sResponse, "\r\n\r\n") + 4);

      if ($this->has_body != 0)
        $this->m_header = substr($sResponse, 0, strpos($sResponse, "\r\n\r\n") + 4);
    }

    // echo $sResponse . "\n";

    return $sResponse;
  }

  public function close()
  {
    curl_close($this->m_handle);
    return;
  }

}


class HEAD_response
{
  public $headers;
  public $code;

  public function HEAD_response($url)
  {
    $conn = new CCurl();

    while (TRUE)
    {
      $conn->set_url($url);
      $conn->include_header(1);
      $conn->set_http_request_method("HEAD");

      $conn->execute();

      $harray = explode("\r\n", $conn->m_header);
      $this->headers = get_http_headers($conn->m_header);

      // echo $harray[0] . "\n";
      // print_r($this->headers);

      $this->code = http_response_code($harray[0]);

      if (($this->code >= 301 && $this->code <= 303) || $this->code == 307)
      {
        $url = $this->headers["Location"];
	// echo "Redicting to: " . $url . "\n";
      }
      else
      {
        break;
      }

    } // while (TRUE)

    $conn->close();

  } // public function HEAD_response($url)

} // class HEAD_response




function http_response_code($line)
{
  $h_line1 = explode(" ", $line);
  $ret = $h_line1[1];
  return $ret;
}




function get_http_headers($header_str)
{
  $lines = explode("\r\n", $header_str);
  array_shift($lines);
  $headers = array();

  foreach ($lines as $line)
  {
    if (strlen($line) < 2)
    {
      continue;
    }

    $header = explode(": ", $line);
    $headers[$header[0]] = $header[1];
  }

  return $headers;
}


    

function download_file($url, $writer_proc)
{
  $conn = new CCurl();

  $conn->set_url($url);
  $conn->include_header(0);
  $conn->set_http_request_method("GET");
  $conn->set_writer_function($writer_proc);

  $conn->execute();
  $conn->close();
}

?>
