<?php


include("common.php");
include("JSON.php");


/* Possible values:
 * 
 * [1] all => To show all downloads.
 * [2] my  => To show ONLY My downloads.
 * 
 * If $show_type isn't one of the above, assume it to be "my".
 *
 */
$show_type = $_GET["showtype"];

/* Set the no-cache header. */
header("Cache-Control: no-cache");


/* Read all the directory entries in the download directory. */

$files = all_files_in_dir($download_dir);


if ($show_type !== "all")
{
  /* Intersect the user's files, and the ones we have. */
  $file_list = get_file_list_from_cookie($cookie_name);

  $files_to_show = array_intersect($files, $file_list);
}
else
{
  $files_to_show = $files;
}

// print_r($files_to_show);

$curr_time = time();

$jsons = array();

$sjson = new Services_JSON();

// echo "Hello";


foreach ($files_to_show as $file)
{
  $fmd_path = $metadata_dir . $file;
  $fdata_path = $download_dir . $file;

  $file_info = stat($fdata_path);
  $file_metadata = file($fmd_path);

  $entry = array();

  $entry["fname"] = urlencode($file);

  if ($file_info === FALSE)
  {
    continue;
  }

  if ($file_metadata !== FALSE)
  {
    $entry["url"]     = urlencode(rtrim($file_metadata[0]));
    $entry["btot"]    = rtrim($file_metadata[1]);
    $entry["tstart"]  = rtrim($file_metadata[2]);
    $entry["status"]  = rtrim($file_metadata[3]);
  }
  else
  {
    $entry["url"]     = urlencode("Unknown URL");
    $entry["btot"]    = -1;
    $entry["tstart"]  = $file_info["mtime"];
    $entry["status"]  = 3;
  }

  $entry["bdone"]  = $file_info["size"];
  $entry["tcurr"]  = $file_info["mtime"];

  $jsons[ ] = $sjson->encode($entry);

}

if (($show_type !== "all") && 
     (sizeof($file_list) !== sizeof($files_to_show)))
{
  /* Set the cookie on the user's machine. */
  setcookie($cookie_name, implode("/", $files_to_show), time() + 34560000);
}


$json_string = implode(";", $jsons);

echo $json_string;


?>
